Browse Source

nixpkgs/neovim: build treesitter grammars ourselves

Thomas Dy 1 year ago
parent
commit
06da1825f6

+ 8 - 23
.config/nixpkgs/neovim/neovim.nix

@@ -1,9 +1,11 @@
 { lib
 , stdenv
+, runCommand
 , writeShellScriptBin
 , writeTextFile
 , neovim-unwrapped
 , makeWrapper
+, tree-sitter
 , fd
 , ripgrep
 , html-tidy
@@ -60,29 +62,7 @@ let
   ];
 
   nixpkgsPlugins =
-    let
-      # we take nvim-treesitter from nixpkgs as the plugin and grammar versions
-      # must match exactly
-      nvim-treesitter = (vimPlugins.nvim-treesitter.withPlugins (p: with p; [
-        tree-sitter-bash
-        tree-sitter-css
-        tree-sitter-elvish
-        tree-sitter-http
-        tree-sitter-go
-        tree-sitter-javascript
-        tree-sitter-json
-        tree-sitter-lua
-        tree-sitter-markdown
-        tree-sitter-nix
-        tree-sitter-ruby
-        tree-sitter-tsx
-        tree-sitter-typescript
-      ] ++ lib.optionals withPlayground [
-        tree-sitter-query
-      ]));
-    in
-    [ nvim-treesitter ] ++ nvim-treesitter.dependencies
-    ++ (lib.optionals withPlayground [
+    (lib.optionals withPlayground [
       vimPlugins.playground
     ])
     ++ (lib.optionals withLuadev [
@@ -93,7 +73,12 @@ let
     inherit buildNeovimPlugin fetchFromGitHub fetchpatch;
   };
 
+  treesitterPlugins = import ./treesitter {
+    inherit lib runCommand fetchFromGitHub tree-sitter;
+  };
+
   plugins = (lib.attrValues pinnedPlugins)
+    ++ (lib.attrValues treesitterPlugins)
     ++ nixpkgsPlugins
     ++ [
       extra-treesitter-textobjects

+ 4 - 0
.config/nixpkgs/neovim/plugins/sources.json

@@ -95,5 +95,9 @@
   "hrsh7th/vim-vsnip": {
     "rev": "7753ba9c10429c29d25abfd11b4c60b76718c438",
     "sha256": "1l8myq6c5rckk6jr3s5rx9jpnrgzk1a65yky1b28mvayd6yff4vs"
+  },
+  "nvim-treesitter/nvim-treesitter": {
+    "rev": "572a15f171ce1a69ed91ea642ae77af5b5d295fb",
+    "sha256": "1vndcc5bnbb4l68lk0pm6gray1f7jf9vxhpxh71mq2lzzpjah8v3"
   }
 }

+ 32 - 0
.config/nixpkgs/neovim/treesitter/default.nix

@@ -0,0 +1,32 @@
+{ lib, runCommand, fetchFromGitHub, tree-sitter }:
+let
+  grammars = builtins.fromJSON (builtins.readFile ./grammars.json);
+
+  buildTreesitterPlugin = name: spec:
+    let
+      nameParts = builtins.split "/" (spec.repo or "tree-sitter/tree-sitter-${name}");
+      owner = builtins.head nameParts;
+      repo = builtins.elemAt nameParts 2;
+
+      grammar = tree-sitter.buildGrammar ({
+        language = name;
+        version = "0.0.0+rev=${spec.rev}";
+
+        src = fetchFromGitHub {
+          inherit owner repo;
+          inherit (spec) rev sha256;
+        };
+      } // lib.optionalAttrs (builtins.hasAttr "path" spec) {
+        location = spec.path;
+      });
+    in
+    runCommand "tree-sitter-${name}" {
+      passthru = {
+        inherit grammar;
+      };
+    } ''
+      mkdir -p $out/parser
+      ln -s ${grammar}/parser $out/parser/${name}.so
+    '';
+in
+builtins.mapAttrs buildTreesitterPlugin grammars

+ 64 - 0
.config/nixpkgs/neovim/treesitter/grammars.json

@@ -0,0 +1,64 @@
+{
+  "bash": {
+    "rev": "493646764e7ad61ce63ce3b8c59ebeb37f71b841",
+    "sha256": "19g7qwdbvch8wz5w0pxqd9n52snb3qzidskzr1m6aswrhzf4apl2"
+  },
+  "css": {
+    "rev": "769203d0f9abe1a9a691ac2b9fe4bb4397a73c51",
+    "sha256": "05875jmkkklx0b5g1h4qc8cbgcj8mr1n8slw7hsn0wssn7yn42z5"
+  },
+  "elvish": {
+    "repo": "thatsmydoing/tree-sitter-elvish",
+    "branch": "fix-elif",
+    "rev": "e2eea328b2a748320bf471759f07f3b8d74ba8f8",
+    "sha256": "1609rv825f65n6c7nwn5xwzfjc8386wbykqfc61ym2r1c81r1srw"
+  },
+  "http": {
+    "repo": "rest-nvim/tree-sitter-http",
+    "rev": "6824a247d1326079aab4fa9f9164e9319678081d",
+    "sha256": "0vhipdljx3s2pgzdk2a1zgqf8dd7p3bdbjckcb6z01hdg2p9v121"
+  },
+  "go": {
+    "rev": "7a4edcbc376302efa8d6ba7e235070ab7ee3c4c8",
+    "sha256": "0mz1khkwys3837q60vmsz7z8mvywcgiqmbcpxh0wfjf79wajrwsn"
+  },
+  "javascript": {
+    "rev": "5720b249490b3c17245ba772f6be4a43edb4e3b7",
+    "sha256": "19bbxpg98bzbg7rh7y4kcfzg8lv7yp00pv1mqfyy913dfx4hnadd"
+  },
+  "json": {
+    "rev": "40a81c01a40ac48744e0c8ccabbaba1920441199",
+    "sha256": "0zji769g3nikqlwn0vb0h93908a7w59da4jf807r9g2s6fvmz4vx"
+  },
+  "lua": {
+    "repo": "MunifTanjim/tree-sitter-lua",
+    "rev": "7268c1cea5df56ac0c779cd37d6631d4e6f41d4f",
+    "sha256": "1m1h0jdjppdf1m1sp14axam4gsz8asas57l0g06kd2jasmn4gd0s"
+  },
+  "markdown": {
+    "repo": "MDeiml/tree-sitter-markdown",
+    "path": "tree-sitter-markdown",
+    "rev": "936cc84289f6de83c263ae8e659fb342867ceb16",
+    "sha256": "0hrn71rl973z0ynwqxhgrjamr1ramfwgkdsrfq60x99fzfrmjfkw"
+  },
+  "nix": {
+    "repo": "nix-community/tree-sitter-nix",
+    "rev": "14b53610c9038500066c509b2e67de04775b97fe",
+    "sha256": "06crcgfx69pdf6sxii45vdrz18vmyrxsxfvr6vw9v0rabbwvznhl"
+  },
+  "ruby": {
+    "rev": "f257f3f57833d584050336921773738a3fd8ca22",
+    "sha256": "0pqcjggdshdmgvnmp9vlsxxgajz1r8c26ipdnjqa2zdvxvs98inh"
+  },
+  "tsx": {
+    "repo": "tree-sitter/tree-sitter-typescript",
+    "path": "tsx",
+    "rev": "3429d8c77d7a83e80032667f0642e6cb19d0c772",
+    "sha256": "1db756vq08ff95m74phjmlqjzbdwmc74lrdqz3lwgfvv5k2g3k58"
+  },
+  "typescript": {
+    "path": "typescript",
+    "rev": "3429d8c77d7a83e80032667f0642e6cb19d0c772",
+    "sha256": "1db756vq08ff95m74phjmlqjzbdwmc74lrdqz3lwgfvv5k2g3k58"
+  }
+}

+ 59 - 0
.config/nixpkgs/neovim/treesitter/update-treesitter.sh

@@ -0,0 +1,59 @@
+#!/usr/bin/env bash
+# shellcheck disable=SC2016
+
+set -euo pipefail
+
+treesitter_rev=$(jq -r '.["nvim-treesitter/nvim-treesitter"].rev' ../plugins/sources.json)
+
+lockfile=$(curl -L -sf "https://github.com/nvim-treesitter/nvim-treesitter/raw/$treesitter_rev/lockfile.json")
+
+grammars=$(< grammars.json)
+
+get_revision() {
+  jq -r ".$1.revision" <<<"$lockfile"
+}
+
+q() {
+  jq -r "$@" <<<"$grammars"
+}
+
+u() {
+  grammars=$(jq "$@" <<<"$grammars")
+}
+
+update_grammar() {
+  name=$1
+  repo=$(q --arg name "$name" '.[$name].repo // "tree-sitter/tree-sitter-\($name)"')
+
+  echo "Updating $name" >&2
+
+  revision=$(get_revision "$name")
+  if branch=$(q -e --arg name "$name" '.[$name].branch'); then
+    revision=$(git ls-remote "https://github.com/$repo" "$branch" | cut -b -40)
+  fi
+  sha256=$(nix-prefetch-url --unpack "https://github.com/$repo/archive/$revision.tar.gz")
+
+  u --arg name "$name" --arg rev "$revision" --arg sha256 "$sha256" '
+    .[$name] = (.[$name] // {}) * {
+      rev: $rev,
+      sha256: $sha256,
+    }
+  '
+}
+
+update_all() {
+  for grammar in $(q 'to_entries | .[] | .key'); do
+    update_grammar "$grammar"
+  done
+}
+
+if [ "$#" -eq 0 ]; then
+  update_all
+else
+  while [ "$#" -gt 0 ]; do
+    update_grammar "$1"
+    shift
+  done
+fi
+
+echo "$grammars" > grammars.json